Bug 6845 - ICE with -O -march=pentium3/pentium2/athlon
ICE with -O -march=pentium3/pentium2/athlon
Status: RESOLVED FIXED
Product: gcc
Classification: Unclassified
Component: rtl-optimization
3.2
: P3 normal
: ---
Assigned To: Richard Henderson
: ice-on-valid-code
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2002-05-28 06:56 UTC by Torbjörn Wassberg
Modified: 2003-07-25 17:33 UTC (History)
3 users (show)

See Also:
Host:
Target:
Build:
Known to work:
Known to fail:
Last reconfirmed:


Attachments
a.i (220 bytes, text/x-c)
2003-05-21 15:17 UTC, Torbjörn Wassberg
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Torbjörn Wassberg 2002-05-28 06:56:00 UTC
I found this when trying to compile lbreakout 2.2.2

It only triggers when using -O or higher together with -march=pentium3, -march=pentium2 or -march=athlon (and perhaps others)

a.c: In function `circle_intersect':
a.c:10: Internal compiler error in ix86_secondary_memory_needed, at config/i386/i386.c:13513
Please submit a full bug report,
with preprocessed source if appropriate.
See <URL:http://www.gnu.org/software/gcc/bugs.html> for instructions.

I'm not sure if
Vector delta = { pos.x - m.x, pos.y - m.y };
is legal, but it doesn't generate any warnings.

Release:
gcc version 3.2 20020527 (experimental)

Environment:
Mandrake 8.2 x86
Configured with: ../gcc/configure --prefix=/usr/local/gcc/ --enable-languages=c
Comment 1 Torbjörn Wassberg 2002-05-28 06:56:00 UTC
Fix:
Replace
Vector delta = { pos.x - m.x, pos.y - m.y };
with
Vector delta;
delta.x = pos.x - m.x;
delta.y = pos.y - m.y;
Comment 2 Richard Henderson 2002-05-28 11:12:39 UTC
State-Changed-From-To: open->feedback
State-Changed-Why: Should have been fixed by 
    
    Sun May 26 14:00:44 CEST 2002  Jan Hubicka  <jh@suse.cz>
    
            * reload.c (find_valid_class): Accept new argument DEST,
            choose class accordingly.
            (push_reload): Update callers.
    
    Can you confirm?
Comment 3 Richard Henderson 2002-05-28 14:02:38 UTC
State-Changed-From-To: feedback->open
State-Changed-Why: Not fixed.
Comment 4 Torbjörn Wassberg 2002-05-28 22:56:52 UTC
From: =?iso-8859-1?q?Torbj=F6rn=20Wassberg?= <torbjorn.wassberg@swipnet.se>
To: rth@gcc.gnu.org, gcc-bugs@gcc.gnu.org, gcc-prs@gcc.gnu.org,
	nobody@gcc.gnu.org, torbjorn.wassberg@swipnet.se,
	gcc-gnats@gcc.gnu.org
Cc:  
Subject: Re: optimization/6845: ICE with -O -march=pentium3/pentium2/athlon
Date: Tue, 28 May 2002 22:56:52 +0200

 On Tuesday 28 May 2002 20.12, you wrote:
 > Synopsis: ICE with -O -march=pentium3/pentium2/athlon
 >
 > State-Changed-From-To: open->feedback
 > State-Changed-By: rth
 > State-Changed-When: Tue May 28 11:12:39 2002
 > State-Changed-Why:
 >     Should have been fixed by
 >
 >     Sun May 26 14:00:44 CEST 2002  Jan Hubicka  <jh@suse.cz>
 >
 >             * reload.c (find_valid_class): Accept new argument DEST,
 >             choose class accordingly.
 >             (push_reload): Update callers.
 >
 >     Can you confirm?
 >
 > http://gcc.gnu.org/cgi-bin/gnatsweb.pl?cmd=view%20audit-trail&database=gcc&
 >pr=6845
 still ICE in gcc version 3.2 20020528 (experimental), reload.c was already 
 updated the first time

Comment 5 Jan Hubicka 2002-06-16 22:36:59 UTC
From: jh@suse.cz
To: gcc-gnats@gcc.gnu.org, gcc-prs@gcc.gnu.org, torbjorn.wassberg@swipnet.se,
   gcc-bugs@gcc.gnu.org, nobody@gcc.gnu.org
Cc:  
Subject: Re: optimization/6845: ICE with -O -march=pentium3%2
Date: Sun, 16 Jun 2002 22:36:59 +0200

 http://gcc.gnu.org/cgi-bin/gnatsweb.pl?cmd=view%20audit-trail&database=gcc&pr=
 6845
Comment 6 Richard Henderson 2002-10-02 13:39:43 UTC
Responsible-Changed-From-To: unassigned->rth
Responsible-Changed-Why: .
Comment 7 Richard Henderson 2002-10-02 13:39:43 UTC
State-Changed-From-To: open->closed
State-Changed-Why: http://gcc.gnu.org/ml/gcc-patches/2002-10/msg00121.html